"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var VersionInfo_1 = require("./VersionInfo");
var Field = /** @class */ (function (_super) {
    __extends(Field, _super);
    function Field(repoField, repo) {
        var _this = _super.call(this, repoField) || this;
        _this.repoField = repoField;
        _this.repo = repo;
        return _this;
    }
    Object.defineProperty(Field.prototype, "id", {
        get: function () {
            return this.repoField.id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "name", {
        get: function () {
            return this.repoField.name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "type", {
        get: function () {
            var codeSet = this.codeSet;
            if (codeSet) {
                return codeSet;
            }
            return this.repo.getDataType(this.repoField.type);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "unionDataType", {
        get: function () {
            return this.repoField.unionDataType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "codeSet", {
        get: function () {
            if (this.repoField.type.endsWith('CodeSet')) {
                return this.repo.getCodeSet(this.repoField.type);
            }
            return undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "lengthId", {
        get: function () {
            return this.repoField.lengthId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "lengthName", {
        get: function () {
            return this.repoField.lengthName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "abbrName", {
        get: function () {
            return this.repoField.abbrName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "issue", {
        get: function () {
            return this.repoField.issue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "documentation", {
        get: function () {
            return this.repoField.documentation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "baseCategroy", {
        get: function () {
            if (this.repoField.baseCategory) {
                return this.repo.getCategory(this.repoField.baseCategory);
            }
            return undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "baseCategoryAbbrName", {
        get: function () {
            return this.repoField.baseCategoryAbbrName;
        },
        enumerable: true,
        configurable: true
    });
    Field.prototype.toJSON = function () {
        return this.repoField;
    };
    Field.prototype.toString = function () {
        return this.name;
    };
    return Field;
}(VersionInfo_1.VersionInfo));
exports.Field = Field;

//# sourceMappingURL=Field.js.map
